#include <math.h>  
//For recieving data from the camera
const byte numChars = 32;
char receivedChars[numChars];
boolean newData = false;

unsigned long start_prev_time = 0;
unsigned long serial_data_received_time;
long check_time;

// Motor R (A)
int enR = 5;
int in1 = 7;
int in2 = 8;

// Motor L (B)
int enL = 6;
int in3 = 9;
int in4 = 10;

const int rPingPin = 4; // Trigger Pin of Ultrasonic Sensor//brown
const int rEchoPin = 3; // Echo Pin of Ultrasonic Sensor//green

const int lPingPin = 12; // Trigger Pin of Ultrasonic Sensor// black
const int lEchoPin = 11;// Echo Pin of Ultrasonic Sensor//white

int velocityR = 0; // declare velocity
int velocityL = 0;
int vCorrection = 10;

void setup() {
  // put your setup code here, to run once:
  pinMode(enR, OUTPUT);
  pinMode(in1, OUTPUT);  
  pinMode(in2, OUTPUT);
  
  pinMode(enL, OUTPUT);  
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);

  pinMode(rPingPin, OUTPUT);
  pinMode(rEchoPin, INPUT);

  pinMode(lPingPin, OUTPUT);
  pinMode(lEchoPin, INPUT);
  
  delay(2000); //delay 3 seconds before starting Serial
  serial_data_received_time =millis(); 
  Serial.begin(9600);
  
}

void loop() {
  // put your main code here, to run repeatedly:
  /*digitalWrite(in1, LOW);// Motors off
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW); 
  digitalWrite(in4, LOW);*/
  
  recvWithStartEndMarkers();
  
  if (newData == true) {
    Serial.println("followFace");
    followFace(); 
    delay(100);
  }
  else if (millis() - serial_data_received_time > 5000 ){
    digitalWrite(in1, LOW);// Turn Motors off
    digitalWrite(in2, LOW);
   
    digitalWrite(in3, LOW); 
    digitalWrite(in4, LOW);
    Serial.println("NoFace");
    avoidMotion();
    delay(500);
    }

}

void recvWithStartEndMarkers() {
  static boolean recvInProgress = false;
  static byte ndx = 0;
  char startMarker = '<';
  char endMarker = '>';
  char rc;

  while (Serial.available() > 0 && newData == false) {
    rc = Serial.read();

    if (recvInProgress == true) {
      if (rc != endMarker) {
        receivedChars[ndx] = rc;
        ndx++;
        if (ndx >= numChars) {
          ndx = numChars - 1;
        }
      }
      else {
        receivedChars[ndx] = '\0'; // terminate the string
        recvInProgress = false;
        ndx = 0;
        newData = true;
      }
    }

    else if (rc == startMarker) {
      recvInProgress = true;
    }
  }
}

void followFace() {
    serial_data_received_time = millis();
    int pan;
    int result = sscanf(receivedChars, "%i", &pan);

    Serial.print("pan");
    Serial.println(pan);

    int  new_setting_car_speed = map(pan, 0, 320, -255, 255); // face distance from center,  mapped to forward/reverse speed
    
    Serial.print("new_setting_car_speed");
    Serial.println(new_setting_car_speed);
    
    if (new_setting_car_speed < -20) {
      boolean inDanger;
      //inDanger = checkSafety();
      
      inDanger = false;
      if(inDanger == false)
      {
        digitalWrite(in3, LOW); // Set Motor L forward
        digitalWrite(in4, HIGH);
        //delay(50);
        digitalWrite(in1, LOW);//Set Motor R forward
        digitalWrite(in2, HIGH);
     
        new_setting_car_speed = sqrt(-new_setting_car_speed)*13;
        velocityR = new_setting_car_speed;
        velocityL = new_setting_car_speed;
        /*for(int i = 1; i<6; i++){
        analogWrite(enR, velocityR*(i/5));//Assign Speed
        analogWrite(enL, (velocityL + vCorrection)*(i/5));
        delay(30);
        }*/
        analogWrite(enR, velocityR);//Assign Speed
        analogWrite(enL, (velocityL + vCorrection));
        Serial.println("following");
        delay(200);
      }
    }
    else if (new_setting_car_speed > 20) {
      
      digitalWrite(in3, HIGH); // Set Motor L backwards
      digitalWrite(in4, LOW);
      //delay(100);
      digitalWrite(in1, HIGH);//Set Motor R backwards
      digitalWrite(in2, LOW);

      new_setting_car_speed = sqrt(new_setting_car_speed)*13;
      velocityR = new_setting_car_speed;
      velocityL = new_setting_car_speed;

      /*for(int i = 1; i<6; i++){
        analogWrite(enR, velocityR*(i/5));//Assign Speed
        analogWrite(enL, (velocityL + vCorrection)*(i/5));
        delay(30);
        }*/

      analogWrite(enR, velocityR);//Assign Speed
      analogWrite(enL, (velocityL + vCorrection));

      Serial.println("backFollowing");
      delay(200);
    }
    else{
      
      digitalWrite(in1, LOW);// Turn Motors off
      digitalWrite(in2, LOW);
   
      digitalWrite(in3, LOW); 
      digitalWrite(in4, LOW);

      velocityR = 0;
      velocityL = 0;

      analogWrite(enR, velocityR);//Assign Speed
      analogWrite(enL, velocityL);
      Serial.println("Center!");delay(200);
    }

    Serial.println("Speed:");
    Serial.print(velocityR);

    digitalWrite(in1, LOW);// Turn Motors off
    digitalWrite(in2, LOW);
   
    digitalWrite(in3, LOW); 
    digitalWrite(in4, LOW);
    
    newData = false;
    //rgb.lightOff();
}

void avoidMotion(){
  long rDuration =0;
  long lDuration =0;
  int fullSpeed = 140;
  int turnSpeedFast = 110;
  int turnSpeedSlow = 100;
  int avoidDistance = 35;
  
  digitalWrite(rPingPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(rPingPin, LOW);
  rDuration = pulseIn(rEchoPin, HIGH);
  long cmR = microsecondsToCentimeters(rDuration);

  delay(100);
  
  digitalWrite(lPingPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(lPingPin, LOW);
  lDuration = pulseIn(lEchoPin, HIGH);
  long cmL = microsecondsToCentimeters(lDuration);

  Serial.println(cmR);
  Serial.println(cmL);

  // define motor velocity in relation to ultrassonic sensor
  
   if (cmR > avoidDistance && cmL > avoidDistance) //straight full speed
   {
      Serial.println("Straight");
      velocityR = fullSpeed;
      velocityL = fullSpeed; 
      //Set Motor R forward
      digitalWrite(in1, LOW);
      digitalWrite(in2, HIGH);
   
      // Set Motor L forward
      digitalWrite(in3, LOW);
      digitalWrite(in4, HIGH);

      analogWrite(enR, velocityR);//Assign Speed
      analogWrite(enL, velocityL + vCorrection);
     
   }
   else if (cmR < avoidDistance && cmL < avoidDistance) // Backup and turn a bit
   {
    Serial.println("Backwards");
    velocityL = turnSpeedSlow;
    velocityR = turnSpeedFast;
   
    //Set Motor R backwards
    digitalWrite(in1, HIGH);
    digitalWrite(in2, LOW);
   
    // Set Motor L backwards
    digitalWrite(in3, HIGH);
    digitalWrite(in4, LOW);

    analogWrite(enR, velocityR);//Assign Speed
    analogWrite(enL, velocityL + vCorrection);
    delay(1000);
   }
   else // closer one full speed, further one 10* cm speed
   {
    Serial.println("Turn");
    if(cmR > cmL){
      velocityL = turnSpeedFast;
      velocityR = 0;
    }
    else{
      velocityL = 0;
      velocityR = turnSpeedFast;
      }
    //Set Motor R forward
     digitalWrite(in1, LOW);
     digitalWrite(in2, HIGH);
   
     // Set Motor L forward
     digitalWrite(in3, LOW);
     digitalWrite(in4, HIGH);

     analogWrite(enR, velocityR);//Assign Speed
     analogWrite(enL, velocityL + vCorrection);
   }
  }

boolean checkSafety(){
  long rDuration =0;
  long lDuration =0;
  int fullSpeed = 180;
  int turnSpeedFast = 150;
  int turnSpeedSlow = 130;
  int avoidDistance = 35;
  
  digitalWrite(rPingPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(rPingPin, LOW);
  rDuration = pulseIn(rEchoPin, HIGH);
  long cmR = microsecondsToCentimeters(rDuration);

  delay(50);
  
  digitalWrite(lPingPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(lPingPin, LOW);
  lDuration = pulseIn(lEchoPin, HIGH);
  long cmL = microsecondsToCentimeters(lDuration);

  Serial.println(cmR);
  Serial.println(cmL);

  // define motor velocity in relation to ultrassonic sensor
  
   if (cmR < avoidDistance && cmL < avoidDistance) // Turn away
   {
    /*Serial.println("SlightTurn");
    
    velocityL = 0;
    velocityR = turnSpeedFast;
    
    //Set Motor R forward
     digitalWrite(in1, LOW);
     digitalWrite(in2, HIGH);
   
     // Set Motor L forward
     digitalWrite(in3, LOW);
     digitalWrite(in4, HIGH);

     analogWrite(enR, velocityR);//Assign Speed
     analogWrite(enL, velocityL);
     delay(500);
     
     digitalWrite(in1, LOW); //Off
     digitalWrite(in2, LOW);
     digitalWrite(in3, LOW);
     digitalWrite(in4, LOW);*/
     Serial.print("danger!");
     
     return(true);
   }
   else{return(false);}
  }
long microsecondsToCentimeters(long microseconds) {
   return microseconds / 29 / 2;
}
